//+------------------------------------------------------------------+
//|                                Daily range and locking trade.mq4 |
//|                                                                * |
//|                                                                * |
//+------------------------------------------------------------------+
#property copyright "*"
#property link      "*"

//---- input parameters
extern int        StartHour = 0;
extern int        SL = 50;
extern int        Step10 = 10;
extern int        Step20 = 20;
extern double     Lots=0.1;

extern int        fast_ema_period=12;
extern int        slow_ema_period=26;
extern int        signal_period=9;
extern int        applied_price=0;    
   //PRICE_CLOSE 0 Close price. 
   //PRICE_OPEN 1 Open price. 
   //PRICE_HIGH 2 High price. 
   //PRICE_LOW 3 Low price. 
   //PRICE_MEDIAN 4 Median price, (high+low)/2. 
   //PRICE_TYPICAL 5 Typical price, (high+low+close)/3. 
   //PRICE_WEIGHTED 6 Weighted close price, (high+low+close+close)/4. 
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   if(DayOfWeek() == 1) return(0); // Don't trade on Monday
   
   static double BUY_level, SELL_level;
   
   int magic = 11111;
   int ticket;
   static datetime myTime;
   bool myTrades;
   
   if(Hour() == StartHour) // Time to define buy/sell levels
   {
      if(myTime != iTime(NULL,PERIOD_D1,0))
      {
         myTime = iTime(NULL,PERIOD_D1,0);
   
         double myMACD = iMACD(NULL, PERIOD_D1, fast_ema_period, slow_ema_period, signal_period, applied_price, MODE_MAIN, 0);
         double mySignal = iMACD(NULL, PERIOD_D1, fast_ema_period, slow_ema_period, signal_period, applied_price, MODE_SIGNAL, 0);
   
         if(myMACD > mySignal) 
         {
            BUY_level = Ask - Step20*Point; //, 3, Bid - SL*Point, Bid + TP*Point, NULL, magic, myTime + 23*60*60, Green);
            SELL_level = Bid + Step10*Point; //, 3, Ask + SL*Point, Ask - TP*Point, NULL, magic, myTime + 23*60*60, Red);
         } else {
            BUY_level = Ask - Step10*Point; //, 3, Bid - SL*Point, Bid + TP*Point, NULL, magic, myTime + 23*60*60, Green);
            SELL_level = Bid + Step20*Point; //, 3, Ask + SL*Point, Ask - TP*Point, NULL, magic, myTime + 23*60*60, Red);
         }
      }
   }
   
   for(int i=0;i<OrdersTotal();i++)
   {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==false) break;
      if(OrderSymbol()==Symbol() && OrderMagicNumber()==magic)
      {
         myTrades = true;
         ticket = OrderTicket();
      }
   }

   if(BUY_level != 0)
   {
      if(myTrades == false) {
         if(Ask < BUY_level) 
         {
            OrderSend(Symbol(),0,Lots,Ask,3,Bid-SL*Point,Bid+(Step10+Step20)*Point,NULL,magic,0,Green);
            BUY_level = 0;
         }
         if(Bid > SELL_level)
         {
            OrderSend(Symbol(),1,Lots,Bid,3,Ask+SL*Point,Ask-(Step10+Step20)*Point,NULL,magic,0,Red);
            BUY_level = 0;
         }
      }
   }
   
   
   if(TimeCurrent() > myTime + 23.5 * 60 * 60) 
   {
      BUY_level = 0;
      if(myTrades == true) {
         OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES);
         if(OrderType() == 0) OrderClose(ticket,OrderLots(),Bid,3,Pink);
         if(OrderType() == 1) OrderClose(ticket,OrderLots(),Ask,3,Pink);
      }
   }


   
   
//----
   return(0);
  }
//+------------------------------------------------------------------+